/*
   Copyright 2013 Unicamp / CCUEC / DDS / CTMQ

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License. 
 */
package br.unicamp.ccuec.ctmq.util;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.mail.Address;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeUtility;

/**
 * Envio de e-mails baseado em postfix
 * 
 * @author clayton@ccuec.unicamp.br	 (Denis Clayton Alves Ramos)
 * 
 */
public class MailHelper {
	private static final String _MSG = "\n\n *** N\u00c3O FOI POSS\u00cdVEL ENVIAR E-MAIL DE ALERTA AVISANDO PROBLEMA COMUNICA\u00c7\u00c3O COM DAEMON ANTI-VIRUS. AVISE POR FAVOR A DDS E DSSOF! ***\n\n";

	private static final Logger _LOGGER = Logger.getLogger(MailHelper.class
			.getName());

	public static void alert(String[] recipients, String[] copyRecipients,
			String subject, String message) {
		try {
			if (recipients == null) {
				return;
			}
			Properties props = new Properties();
			props.put("mail.transport.protocol", "smtp");
			props.put("mail.smtp.host", "localhost");
			props.put("mail.smtp.port", 25);
			props.put("mail.mime.charset", "ISO-8859-1");
			props.put("mail.user", "nobody");

/*			String strHostIp = InetAddress.getLocalHost().getHostAddress();
			String strSmtpMailServer = strHostIp.indexOf("143.106.20") > 0 ? _SMTP_CCUEC
					: _SMTP_UNICAMP;
			props.put("mail.smtp.host", strSmtpMailServer);*/

			Session mailSession = Session.getInstance(props, null);
			MimeMessage email = new MimeMessage(mailSession);

			String strEncodedSubject = MimeUtility.encodeText(subject,
					"ISO-8859-1", null);
			email.setSubject(strEncodedSubject, "ISO-8859-1");
			email.setSentDate(new Date());
			email.setContent(message, "text/plain");
			email.setHeader("X-Mailer", "MailCCUEC");

			int ind = 0; 
			Address[] arrayTo = new Address[recipients.length];
			for (String to : recipients) {
				arrayTo[ind] = new InternetAddress(to);
				ind++;
			}
			email.setRecipients(Message.RecipientType.TO, arrayTo);

			if (copyRecipients != null && copyRecipients.length > 0) {
				List<Address> adressesCc = new ArrayList<Address>();
				for (String cc : copyRecipients) {
					adressesCc.add(new InternetAddress(cc));
				}

				email.setRecipients(Message.RecipientType.CC,
						(Address[]) adressesCc.toArray());
			}

			// email.setFrom(new InternetAddress(""));

			Transport.send(email);
		} catch (MessagingException e) {
			_LOGGER.log(Level.SEVERE, _MSG);
			e.printStackTrace();
		} catch (Exception e) {
			_LOGGER.log(Level.SEVERE, _MSG);
			e.printStackTrace();
		}
	}
}