/*
   Copyright 2013 Unicamp / CCUEC / DDS / CTMQ

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License. 
 */
package br.unicamp.ccuec.ctmq.virusScan.spec;

import java.io.InputStream;

/**
 * API para se conectar com anti-virus e checar arquivos. 
 * 
 * @author clayton@ccuec.unicamp.br (Denis Clayton Alves Ramos)
 *
 */
public interface VirusScan {
	/**
	 * Testa se anti-virus esta respondendo. Usado no auto-teste automatico.
	 * 
	 * @return boolean
	 */
	public abstract boolean ping();

	/**
	 * scan java.io.File referenciado pelo path completo
	 * 
	 * @param String
	 * @return boolean
	 * @throws VirusException
	 */
	public abstract boolean scan(String path) throws VirusException, InfraException;

	/**
	 * scan arquivo em memoria
	 * 
	 * @param bytes[]
	 * @return boolean
	 * @throws VirusException
	 */
	public abstract boolean scan(byte[] bytes) throws VirusException, InfraException;

	/**
	 * scan java.io.InputStream
	 * 
	 * @param InputStream
	 * @return boolean
	 * @throws VirusException
	 */
	public abstract boolean scan(InputStream is) throws VirusException, InfraException;
}